<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>
        <v-card max-width="90%">
            <v-card-title>
                <v-layout column>

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.title}}</td>
                            <td>{{ item.start_time}}</td>
                            <td>{{ item.end_time}}</td>
                            <td>{{ item.discount_type === 0 ? 'ریالی' : 'درصدی'}}</td>
                            <td>{{ item.discount_value}}</td>
                            <td>{{ item.for_carriers === 0 ? 'خیر' : 'آره'}}</td>
                            <td>{{ item.for_drivers === 0 ? 'خیر' : 'آره'}}</td>
                            <td>{{ item.for_cargo_owners === 0 ? 'خیر' : 'آره'}}</td>

                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>

                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                        >
                            <v-layout wrap>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setTitle" v-model="selectedItem.title"
                                                  label="عنوان"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-select
                                            v-model="selectedItem.discount_type_model"
                                            :items="discountType"
                                            item-text="name"
                                            outlined
                                            label="نوع تخفیف را انتخاب کنید"
                                            single-line
                                            @change="setDiscountTypeModel"
                                            return-object
                                    ></v-select>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="numberRules"
                                                  type="number" @change="setDiscountValue"
                                                  v-model="selectedItem.discount_value"
                                                  label="مقدار تخفیف"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-checkbox @change="setForCarrier" v-model="selectedItem.for_carriers"
                                                label="برای باربری ها"></v-checkbox>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-checkbox @change="setForDriver" v-model="selectedItem.for_drivers"
                                                label="برای رانندگان"></v-checkbox>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-checkbox @change="setForCargoOwner" v-model="selectedItem.for_cargo_owners"
                                                label="برای صاحبین بار"></v-checkbox>
                                </v-flex>


                                <v-flex xs12 md6 sm6>
                                    <v-select
                                            v-model="selectedItem.vehicle"
                                            :items="vehicleType"
                                            item-text="name"
                                            outlined
                                            label="نوع ماشین را انتخاب کنید"
                                            attach
                                            chips
                                            multiple
                                            @change="setVehicleType"
                                            return-object
                                    ></v-select>
                                </v-flex>


                                <v-flex xs12 md6 sm6>
                                    <v-select
                                            v-model="selectedItem.cargo"
                                            :items="cargoType"
                                            item-text="name"
                                            outlined
                                            label="نوع بار را انتخاب کنید"
                                            attach
                                            chips
                                            multiple
                                            @change="setCargoType"
                                            return-object
                                    ></v-select>
                                </v-flex>

                                <h5 class="ma-1 mr-3">
                                    از:
                                </h5>
                                <date-picker :rules="numberRules" @input="setStartTime" color="#b71c1c" type="datetime"
                                             :value="selectedItem.start_time"></date-picker>
                                <h5 class="ma-1 mr-3">
                                    تا:
                                </h5>
                                <date-picker :rules="numberRules" @input="setEndTime" color="#b71c1c" type="datetime"
                                             :value="selectedItem.end_time"></date-picker>
                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این تخفیف را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";
    import {mask} from 'vue-the-mask';

    export default {
        name: "discount",
        methods: {
            ...mapMutations({
                setTitle: 'discount/setTitle',
                setDiscountType: 'discount/setDiscountType',
                setStartTime: 'discount/setStartTime',
                setEndTime: 'discount/setEndTime',
                setStatus: 'discount/setStatus',
                setDiscountValue: 'discount/setDiscountValue',
                setForCarrier: 'discount/setForCarrier',
                setForDriver: 'discount/setForDriver',
                setForCargoOwner: 'discount/setForCargoOwner',
                setDiscountTypeModel: 'discount/setDiscountTypeModel',
                setSelectedItem: 'discount/setSelectedItem',
                showAddDialog: 'discount/showAddDialog',
                hideAddDialog: 'discount/hideAddDialog',
                showDeleteDialog: 'discount/showDeleteDialog',
                hideDeleteDialog: 'discount/hideDeleteDialog',
                setVehicleType: 'discount/setVehicleType',
                setCargoType: 'discount/setCargoType',

            }),
            ...mapActions({
                readData: 'discount/readData',
                addOrEdit: 'discount/addOrEdit',
                deleteOne: 'discount/deleteOne'
            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    title: null,
                    start_time: null,
                    end_time: null,
                    discount_type: null,
                    discount_type_model: {name: 'ریالی', type: 0},
                    status: null,
                    discount_value: null,
                    for_carriers: null,
                    for_drivers: null,
                    for_cargo_owners: null,
                    vehicle:null,
                    cargo:null,
                });
                this.showAddDialog();
            },
            edit(item) {
                if (item.discount_type === 0) {
                    item.discount_type_model = {name: 'ریالی', type: 0};
                } else {
                    item.discount_type_model = {name: 'درصدی', type: 1};
                }
                this.setSelectedItem({
                    id: item.id,
                    title: item.title,
                    start_time: item.start_time,
                    end_time: item.end_time,
                    discount_type: item.discount_type,
                    discount_type_model: item.discount_type_model,
                    status: item.status,
                    discount_value: item.discount_value,
                    for_carriers: item.for_carriers,
                    for_drivers: item.for_drivers,
                    for_cargo_owners: item.for_cargo_owners,
                });
                this.showAddDialog();
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
        },
        computed: {
            ...mapState({
                allData: state => state.discount.allData,
                discountType: state => state.discount.discountType,

                AddDialog: state => state.discount.AddDialog,
                DeleteDialog: state => state.discount.DeleteDialog,
                selectedItem: state => state.discount.selectedItem,
                pending: state => state.discount.pending,
                allDataLoading: state => state.discount.allDataLoading,
                vehicleType: state => state.discount.vehicleType,
                cargoType: state => state.discount.cargoType,

            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                    v => (!v || v.length >= 4) || 'حداقل باید 4 کاراکتر بنویسید',
                ],
                numberRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                headers: [
                    {text: 'عنوان', align: 'right', value: 'title'},
                    {text: 'زمان شروع', align: 'right', value: 'start_time'},
                    {text: 'زمان پایان', align: 'right', value: 'end_time'},
                    {text: 'نوع تخفیف', align: 'right', value: 'discount_type'},
                    {text: 'مقدار', align: 'right', value: 'discount_value'},
                    {text: 'برای باربری', align: 'right', value: 'for_carriers'},
                    {text: 'برای راننده', align: 'right', value: 'for_drivers'},
                    {text: 'برای صاحب بار', align: 'right', value: 'for_cargo_owners'},
                ],
            }
        },

    }
</script>
<style scoped>
</style>
